## leptonlib 1.37

=== prog/Makefile ===
#/*====================================================================*
# -  Copyright (C) 2001 Leptonica.  All rights reserved.
# -  This software is distributed in the hope that it will be
# -  useful, but with NO WARRANTY OF ANY KIND.
# -  No author or distributor accepts responsibility to anyone for the
# -  consequences of using this software, or for whether it serves any
# -  particular purpose or works at all, unless he or she says so in
# -  writing.  Everyone is granted permission to copy, modify and
# -  redistribute this source code, for commercial or non-commercial
# -  purposes, with the following restrictions: (1) the origin of this
# -  source code must not be misrepresented; (2) modified versions must
# -  be plainly marked as such; and (3) this notice may not be removed
# -  or altered from any source or modified source distribution.
# *====================================================================*/

#   Makefile  (for linux)
#
#   For a nodebug version:             make
#   For a debug version:               make DEBUG=yes
#   For a shared library version:      make SHARED=yes
#   With nonstandard library directories:
#                    make EXTRALIBS="-L<nonstandard-lib-dir>"
#   With nonstandard header directories
#                    make EXTRAINCLUDES="-I<nonstandard-incl-dir>"
#
#   To remove all executables:  make clean
#
#   To link and run programs using shared (dynamic linked) libraries,
#   you must do one of the following two things:
#
#     (a)  make sure your LD_LIBRARY_PATH variable points to the
#          directory in which the *.so files are placed, or
#     (b)  have the *.so files (or links to them) in this directory
#
#   On a bigendian machine (e.g., Mac), use
#      CPPFLAGS =	$(INCLUDES) -DL_BIG_ENDIAN
#


# Libraries are built into a binary tree with its root in the
# parent directory
ROOT_DIR = ..

LIB_NODEBUG_DIR =	$(ROOT_DIR)/lib/nodebug
LIB_DEBUG_DIR =		$(ROOT_DIR)/lib/debug
LIB_SHARED_DIR =	$(ROOT_DIR)/lib/shared

# Include files are found within the same tree
IMAGELIB_INCL =	$(ROOT_DIR)/src


CC =		gcc -ansi -Werror -D_BSD_SOURCE -DANSI -fPIC
#CC =            g++ -Werror -D_BSD_SOURCE -fPIC



ifdef  SHARED
    LIB_DIR =	$(LIB_SHARED_DIR)
    OPTIMIZE =	-O2
else
    ifdef  DEBUG
	LIB_DIR =	$(LIB_DEBUG_DIR)
	OPTIMIZE =	-g
    else
	LIB_DIR =	$(LIB_NODEBUG_DIR)
	OPTIMIZE =	-O2
    endif
endif

OPTIONS =

INCLUDES =	-I$(IMAGELIB_INCL) -I/usr/X11R6/include $(EXTRAINCLUDES)
#INCLUDES =	-I$(IMAGELIB_INCL) -I/usr/X11R6/include -I/usr/local/include $(EXTRAINCLUDES)

CFLAGS =	$(OPTIMIZE) $(OPTIONS)
CPPFLAGS =      $(INCLUDES) -DL_LITTLE_ENDIAN
#CPPFLAGS =      $(INCLUDES) -DL_BIG_ENDIAN

LDFLAGS +=	-L$(LIB_DIR) -L/usr/X11R6/lib -L/usr/lib $(EXTRALIBS)
#LDFLAGS +=	-L$(LIB_DIR) -L/usr/X11R6/lib -L/usr/local/lib -L/usr/lib $(EXTRALIBS)

ifdef  SHARED
    LEPTLIB =		$(LIB_DIR)/liblept.so
else
    LEPTLIB =		$(LIB_DIR)/liblept.a
endif

ALL_LIBS =	$(LEPTLIB) -ltiff -ljpeg -lpng -lz -lm

#########################################################################

SRC =		adaptmaptest.c affinetest.c \
		alljpeg2ps.c alltiff2ps.c \
		arithtest.c \
		baselinetest.c bilineartest.c \
		bincompare.c binmazetest.c \
		blendcmaptest.c blendtest1.c buffertest.c \
		ccbordtest.c cctest.c \
		colormaptest.c colorquanttest.c \
		colorsegtest.c colorspacetest.c \
		contrasttest.c convertformat.c converttogray.c \
		converttops.c convolvetest.c cornertest.c \
		distancetest.c dithertest.c docseg1.c \
		equaltest.c expandtest.c falsecolortest.c \
		fhmtautogen.c fhmttest.c fileinfo.c \
		findpattern1.c findpattern2.c findpattern3.c \
		fmorphautogen.c fmorphtest1.c fmorphtest2.c \
		gammatest.c genfonts.c graphicstest.c graymazetest.c \
		heaptest.c histotest.c ioformats.c iotest.c \
		jbcorrelation.c jbrankhaus.c \
		lineremoval.c listtest.c maketile.c \
		morphgraytest.c morphop.c morphseqtest.c \
		morphtest1.c morphtest2.c morphtest3.c morphtest4.c \
		mtifftest.c \
		numaranktest.c numatest.c painttest.c \
		pixcompare.c plotfile.c plotprog.c \
		printimage.c printsplitimage.c printtiff.c \
		projectivetest.c reducetest.c renderfonts.c \
		rotatefastalt.c rotatetest1.c rotatetest2.c \
		rotate90test.c rotate180test.c runlengthtest.c \
		scaletest1.c scaletest2.c scaletest3.c \
		seedfilltest.c \
		sharptest.c sheartest.c showedges.c \
		skewtest.c snapcolortest.c \
		sorttest.c splitimage2pdf.c \
		thresholdtest.c viewertest.c \
		xvdisp.c

XTRACT_SRC =	xtractprotos.c

######################################################################

all:	$(SRC:%.c=%)

######################################################################

adaptmaptest:	adaptmaptest.o $(LEPTLIB)
	$(CC) -o adaptmaptest adaptmaptest.o $(ALL_LIBS) $(EXTRALIBS)

affinetest:	affinetest.o $(LEPTLIB)
	$(CC) -o affinetest affinetest.o $(ALL_LIBS) $(EXTRALIBS)

alljpeg2ps:	alljpeg2ps.o $(LEPTLIB)
	$(CC) -o alljpeg2ps alljpeg2ps.o $(ALL_LIBS) $(EXTRALIBS)

alltiff2ps:	alltiff2ps.o $(LEPTLIB)
	$(CC) -o alltiff2ps alltiff2ps.o $(ALL_LIBS) $(EXTRALIBS)

arithtest:	arithtest.o $(LEPTLIB)
	$(CC) -o arithtest arithtest.o $(ALL_LIBS) $(EXTRALIBS)

baselinetest:	baselinetest.o $(LEPTLIB)
	$(CC) -o baselinetest baselinetest.o $(ALL_LIBS) $(EXTRALIBS)

bilineartest:	bilineartest.o $(LEPTLIB)
	$(CC) -o bilineartest bilineartest.o $(ALL_LIBS) $(EXTRALIBS)

bincompare:	bincompare.o $(LEPTLIB)
	$(CC) -o bincompare bincompare.o $(ALL_LIBS) $(EXTRALIBS)

binmazetest:	binmazetest.o $(LEPTLIB)
	$(CC) -o binmazetest binmazetest.o $(ALL_LIBS) $(EXTRALIBS)

blendcmaptest:	blendcmaptest.o $(LEPTLIB)
	$(CC) -o blendcmaptest blendcmaptest.o $(ALL_LIBS) $(EXTRALIBS)

blendtest1:	blendtest1.o $(LEPTLIB)
	$(CC) -o blendtest1 blendtest1.o $(ALL_LIBS) $(EXTRALIBS)

buffertest:	buffertest.o $(LEPTLIB)
	$(CC) -o buffertest buffertest.o $(ALL_LIBS) $(EXTRALIBS)

ccbordtest:	ccbordtest.o $(LEPTLIB)
	$(CC) -o ccbordtest ccbordtest.o $(ALL_LIBS) $(EXTRALIBS)

cctest:		cctest.o $(LEPTLIB)
	$(CC) -o cctest cctest.o $(ALL_LIBS) $(EXTRALIBS)

colormaptest:	colormaptest.o $(LEPTLIB)
	$(CC) -o colormaptest colormaptest.o $(ALL_LIBS) $(EXTRALIBS)

colorquanttest:	colorquanttest.o $(LEPTLIB)
	$(CC) -o colorquanttest colorquanttest.o $(ALL_LIBS) $(EXTRALIBS)

colorsegtest:	colorsegtest.o $(LEPTLIB)
	$(CC) -o colorsegtest colorsegtest.o $(ALL_LIBS) $(EXTRALIBS)

colorspacetest:	colorspacetest.o $(LEPTLIB)
	$(CC) -o colorspacetest colorspacetest.o $(ALL_LIBS) $(EXTRALIBS)

contrasttest:	contrasttest.o $(LEPTLIB)
	$(CC) -o contrasttest contrasttest.o $(ALL_LIBS) $(EXTRALIBS)

convertformat:	convertformat.o $(LEPTLIB)
	$(CC) -o convertformat convertformat.o $(ALL_LIBS) $(EXTRALIBS)

converttogray:	converttogray.o $(LEPTLIB)
	$(CC) -o converttogray converttogray.o $(ALL_LIBS) $(EXTRALIBS)

converttops:	converttops.o $(LEPTLIB)
	$(CC) -o converttops converttops.o $(ALL_LIBS) $(EXTRALIBS)

convolvetest:	convolvetest.o $(LEPTLIB)
	$(CC) -o convolvetest convolvetest.o $(ALL_LIBS) $(EXTRALIBS)

cornertest:	cornertest.o $(LEPTLIB)
	$(CC) -o cornertest cornertest.o $(ALL_LIBS) $(EXTRALIBS)

distancetest:	distancetest.o $(LEPTLIB)
	$(CC) -o distancetest distancetest.o $(ALL_LIBS) $(EXTRALIBS)

dithertest:	dithertest.o $(LEPTLIB)
	$(CC) -o dithertest dithertest.o $(ALL_LIBS) $(EXTRALIBS)

docseg1:	docseg1.o $(LEPTLIB)
	$(CC) -o docseg1 docseg1.o $(ALL_LIBS) $(EXTRALIBS)

equaltest:	equaltest.o $(LEPTLIB)
	$(CC) -o equaltest equaltest.o $(ALL_LIBS) $(EXTRALIBS)

expandtest:	expandtest.o $(LEPTLIB)
	$(CC) -o expandtest expandtest.o $(ALL_LIBS) $(EXTRALIBS)

falsecolortest:	falsecolortest.o $(LEPTLIB)
	$(CC) -o falsecolortest falsecolortest.o $(ALL_LIBS) $(EXTRALIBS)

fhmtautogen:	fhmtautogen.o $(LEPTLIB)
	$(CC) -o fhmtautogen fhmtautogen.o $(ALL_LIBS) $(EXTRALIBS)

fhmttest:	fhmttest.o $(LEPTLIB)
	$(CC) -o fhmttest fhmttest.o $(ALL_LIBS) $(EXTRALIBS)

fileinfo:	fileinfo.o $(LEPTLIB)
	$(CC) -o fileinfo fileinfo.o $(ALL_LIBS) $(EXTRALIBS)

findpattern1:	findpattern1.o $(LEPTLIB)
	$(CC) -o findpattern1 findpattern1.o $(ALL_LIBS) $(EXTRALIBS)

findpattern2:	findpattern2.o $(LEPTLIB)
	$(CC) -o findpattern2 findpattern2.o $(ALL_LIBS) $(EXTRALIBS)

findpattern3:	findpattern3.o $(LEPTLIB)
	$(CC) -o findpattern3 findpattern3.o $(ALL_LIBS) $(EXTRALIBS)

fmorphautogen:	fmorphautogen.o $(LEPTLIB)
	$(CC) -o fmorphautogen fmorphautogen.o $(ALL_LIBS) $(EXTRALIBS)

fmorphtest1:	fmorphtest1.o $(LEPTLIB)
	$(CC) -o fmorphtest1 fmorphtest1.o $(ALL_LIBS) $(EXTRALIBS)

fmorphtest2:	fmorphtest2.o $(LEPTLIB)
	$(CC) -o fmorphtest2 fmorphtest2.o $(ALL_LIBS) $(EXTRALIBS)

gammatest:	gammatest.o $(LEPTLIB)
	$(CC) -o gammatest gammatest.o $(ALL_LIBS) $(EXTRALIBS)

genfonts:	genfonts.o $(LEPTLIB)
	$(CC) -o genfonts genfonts.o $(ALL_LIBS) $(EXTRALIBS)

graphicstest:	graphicstest.o $(LEPTLIB)
	$(CC) -o graphicstest graphicstest.o $(ALL_LIBS) $(EXTRALIBS)

graymazetest:	graymazetest.o $(LEPTLIB)
	$(CC) -o graymazetest graymazetest.o $(ALL_LIBS) $(EXTRALIBS)

heaptest:	heaptest.o $(LEPTLIB)
	$(CC) -o heaptest heaptest.o $(ALL_LIBS) $(EXTRALIBS)

histotest:	histotest.o $(LEPTLIB)
	$(CC) -o histotest histotest.o $(ALL_LIBS) $(EXTRALIBS)

ioformats:	ioformats.o $(LEPTLIB)
	$(CC) -o ioformats ioformats.o $(ALL_LIBS) $(EXTRALIBS)

iotest:		iotest.o $(LEPTLIB)
	$(CC) -o iotest iotest.o $(ALL_LIBS) $(EXTRALIBS)

jbcorrelation:	jbcorrelation.o $(LEPTLIB)
	$(CC) -o jbcorrelation jbcorrelation.o $(ALL_LIBS) $(EXTRALIBS)

jbrankhaus:	jbrankhaus.o $(LEPTLIB)
	$(CC) -o jbrankhaus jbrankhaus.o $(ALL_LIBS) $(EXTRALIBS)

lineremoval:	lineremoval.o $(LEPTLIB)
	$(CC) -o lineremoval lineremoval.o $(ALL_LIBS) $(EXTRALIBS)

listtest:	listtest.o $(LEPTLIB)
	$(CC) -o listtest listtest.o $(ALL_LIBS) $(EXTRALIBS)

maketile:	maketile.o $(LEPTLIB)
	$(CC) -o maketile maketile.o $(ALL_LIBS) $(EXTRALIBS)

morphgraytest:	morphgraytest.o $(LEPTLIB)
	$(CC) -o morphgraytest morphgraytest.o $(ALL_LIBS) $(EXTRALIBS)

morphop:	morphop.o $(LEPTLIB)
	$(CC) -o morphop morphop.o $(ALL_LIBS) $(EXTRALIBS)

morphseqtest:	morphseqtest.o $(LEPTLIB)
	$(CC) -o morphseqtest morphseqtest.o $(ALL_LIBS) $(EXTRALIBS)

morphtest1:	morphtest1.o $(LEPTLIB)
	$(CC) -o morphtest1 morphtest1.o $(ALL_LIBS) $(EXTRALIBS)

morphtest2:	morphtest2.o $(LEPTLIB)
	$(CC) -o morphtest2 morphtest2.o $(ALL_LIBS) $(EXTRALIBS)

morphtest3:	morphtest3.o $(LEPTLIB)
	$(CC) -o morphtest3 morphtest3.o $(ALL_LIBS) $(EXTRALIBS)

morphtest4:	morphtest4.o $(LEPTLIB)
	$(CC) -o morphtest4 morphtest4.o $(ALL_LIBS) $(EXTRALIBS)

mtifftest:	mtifftest.o $(LEPTLIB)
	$(CC) -o mtifftest mtifftest.o $(ALL_LIBS) $(EXTRALIBS)

numaranktest:	numaranktest.o $(LEPTLIB)
	$(CC) -o numaranktest numaranktest.o $(ALL_LIBS) $(EXTRALIBS)

numatest:	numatest.o $(LEPTLIB)
	$(CC) -o numatest numatest.o $(ALL_LIBS) $(EXTRALIBS)

painttest:	painttest.o $(LEPTLIB)
	$(CC) -o painttest painttest.o $(ALL_LIBS) $(EXTRALIBS)

pixcompare:	pixcompare.o $(LEPTLIB)
	$(CC) -o pixcompare pixcompare.o $(ALL_LIBS) $(EXTRALIBS)

plotfile:	plotfile.o $(LEPTLIB)
	$(CC) -o plotfile plotfile.o $(ALL_LIBS) $(EXTRALIBS)

plotprog:	plotprog.o $(LEPTLIB)
	$(CC) -o plotprog plotprog.o $(ALL_LIBS) $(EXTRALIBS)

printimage:	printimage.o $(LEPTLIB)
	$(CC) -o printimage printimage.o $(ALL_LIBS) $(EXTRALIBS)

printsplitimage:	printsplitimage.o $(LEPTLIB)
	$(CC) -o printsplitimage printsplitimage.o $(ALL_LIBS) $(EXTRALIBS)

printtiff:	printtiff.o $(LEPTLIB)
	$(CC) -o printtiff printtiff.o $(ALL_LIBS) $(EXTRALIBS)

projectivetest:	projectivetest.o $(LEPTLIB)
	$(CC) -o projectivetest projectivetest.o $(ALL_LIBS) $(EXTRALIBS)

reducetest:	reducetest.o $(LEPTLIB)
	$(CC) -o reducetest reducetest.o $(ALL_LIBS) $(EXTRALIBS)

renderfonts:	renderfonts.o $(LEPTLIB)
	$(CC) -o renderfonts renderfonts.o $(ALL_LIBS) $(EXTRALIBS)

rotatefastalt:	rotatefastalt.o $(LEPTLIB)
	$(CC) -o rotatefastalt rotatefastalt.o $(ALL_LIBS) $(EXTRALIBS)

rotatetest1:	rotatetest1.o $(LEPTLIB)
	$(CC) -o rotatetest1 rotatetest1.o $(ALL_LIBS) $(EXTRALIBS)

rotatetest2:	rotatetest2.o $(LEPTLIB)

=== src/Makefile ===
#*====================================================================*
#-  Copyright (C) 2001 Leptonica.  All rights reserved.
#-  This software is distributed in the hope that it will be
#-  useful, but with NO WARRANTY OF ANY KIND.
#-  No author or distributor accepts responsibility to anyone for the
#-  consequences of using this software, or for whether it serves any
#-  particular purpose or works at all, unless he or she says so in
#-  writing.  Everyone is granted permission to copy, modify and
#-  redistribute this source code, for commercial or non-commercial
#-  purposes, with the following restrictions: (1) the origin of this
#-  source code must not be misrepresented; (2) modified versions must
#-  be plainly marked as such; and (3) this notice may not be removed
#-  or altered from any source or modified source distribution.
#*====================================================================*/


#   Makefile  (for linux)
#
#   For a nodebug version:             make
#   For a debug version:               make DEBUG=yes debug
#   For a shared library version:      make SHARED=yes shared
#   For all versions:                  make all
#   With nonstandard header directories
#                    make EXTRAINCLUDES="-I<nonstandard-incl-dir>"
#
#   To remove object files in src: make clean
#   To remove object files and executables in prog: make clean
#
#   Customization for machine hardware:
#   (1) On little-endian machines (e.g., i386, x86-64):
#          CPPFLAGS = $(INCLUDES) -DL_LITTLE_ENDIAN
#       On big-endian machines (e.g., Mac Power PC, Sun Sparc):
#          CPPFLAGS = $(INCLUDES) -DL_BIG_ENDIAN
#   (2) To generate function prototypes, you need a program called
#       xtractprotos.  Build it with this command:
#          make xtractprotos
#       Then 'make allprotos'
#
#   Stuff used by Makefile
RM =		rm -f
TEST =		test
MKDIRHIER =	mkdir -p
LIBRARIAN =	ar cq
RANLIB =	ranlib


# Libraries are built into a binary tree with its root in the parent directory
ROOT_DIR =	..

# To find prog/xtractprotos.c when building the executable
VPATH =	.:../prog

BASE_OBJ =	$(ROOT_DIR)/obj
OBJ_NODEBUG =	$(ROOT_DIR)/obj/nodebug
OBJ_DEBUG =	$(ROOT_DIR)/obj/debug
OBJ_SHARED =	$(ROOT_DIR)/obj/shared

BASE_LIB =	$(ROOT_DIR)/lib
LIB_NODEBUG =	$(ROOT_DIR)/lib/nodebug
LIB_DEBUG =	$(ROOT_DIR)/lib/debug
LIB_SHARED =	$(ROOT_DIR)/lib/shared


# Include files
INCLUDES =	-I./ -I/usr/X11R6/include $(EXTRAINCLUDES)
PROTOTYPE_DIR =	.

# Conditional compilation (depending on processor endian-ness)
CPPFLAGS =	$(INCLUDES) -DL_LITTLE_ENDIAN
#CPPFLAGS =	$(INCLUDES) -DL_BIG_ENDIAN

# Shared library linker options
SONAME_OPTION = -Wl,-h,

ifdef  SHARED
    OPTIMIZE =		-O2 -fPIC
else
    ifdef  DEBUG
	OPTIMIZE =	-g
    else
	OPTIMIZE =	-O2
    endif
endif


#  which to use?
#     use -Werror to verify there are no serious warnings
#     use g++ to apply stricter rules.  Libraries made with g++ may not
#        link to programs compiled with gcc (depends on the glibc version).
#     use -Wunused to verify there are no unused vars
#     use -DNO_CONSOLE_IO to remove all L_INFO, L_WARNING and
#        ERROR_* logging, and to remove all DEBUG information dependent
#        on whether or not NO_CONSOLE_IO has been defined.
#     remove -fPIC to avoid warnings on cygwin
CC =		gcc -ansi -Werror -D_BSD_SOURCE -DANSI -fPIC
#CC =		gcc -ansi -Werror -DNO_CONSOLE_IO -D_BSD_SOURCE -DANSI -fPIC
#CC =		g++ -Werror -D_BSD_SOURCE -fPIC
#CC =		g++ -Wunused -D_BSD_SOURCE -fPIC
#CC =		gcc -ansi -D_BSD_SOURCE -DANSI


OPTIONS =
CFLAGS =		$(OPTIMIZE) $(OPTIONS)
LIBRARIAN_SHARED =	gcc -shared

# Libraries differing only in their minor revision numbers
# are required to have the same interface.  By using
# "-h" in the ld, the "soname" is <libname>.X, where X is
# the major revision number.
# Links are created among the files <libname>.X.Y,
# <libname>.X, and <libname>, where Y is the minor revision number.
MAJOR_REV = 1
MINOR_REV = 37

#########################################################

# Libraries

LEPTLIB =		liblept.a

LEPTLIB_SHARED =	liblept.so

#########################################################

# Source:   (on cygwin, comment out viewfiles.c)

LEPTLIB_C =	adaptmap.c \
		affine.c \
		arithlow.c \
		arrayaccess.c \
		baseline.c \
		bbuffer.c \
		bilinear.c \
		binexpand.c binexpandlow.c \
		binreduce.c binreducelow.c \
		blend.c bmf.c bmpio.c \
		box.c \
		ccbord.c \
		colormap.c colorquant.c colorseg.c \
		conncomp.c \
		convolve.c convolvelow.c \
		enhance.c \
		fhmtauto.c \
		fhmtgen.1.c fhmtgenlow.1.c \
		fmorph.c \
		fmorphauto.c \
		fmorphgen.1.c fmorphgenlow.1.c \
		fmorphlow.c \
		gplot.c graphics.c \
		graymorph.c graymorphlow.c \
		grayquant.c grayquantlow.c \
		jbclass.c jpegio.c \
		list.c maze.c \
		morph.c morphapp.c morphseq.c \
		numarray.c paintcmap.c \
		parseprotos.c pheap.c \
		pix1.c pix2.c pixa.c pixarith.c pixconv.c \
		pngio.c pnmio.c pqueue.c \
		projective.c psio.c \
		pts.c \
		readfile.c \
		rop.c ropiplow.c roplow.c \
		rotate.c rotateam.c rotateamlow.c \
		rotateorth.c rotateorthlow.c \
		rotateshear.c \
		runlength.c \
		sarray.c \
		scale.c scalelow.c \
		seedfill.c seedfilllow.c \
		sel1.c sel2.c selgen.c \
		shear.c skew.c stack.c \
		textops.c tiffio.c utils.c \
		viewfiles.c \
		writefile.c

SRC =		$(LEPTLIB_C)

LEPTLIB_H =	allheaders.h alltypes.h \
		array.h arrayaccess.h bbuffer.h \
		bmf.h bmp.h ccbord.h colorquant.h \
		conncomp.h environ.h gplot.h \
		imageio.h \
		jbclass.h jpeglib.h \
		leptprotos.h list.h \
		morph.h pheap.h \
		pix.h pqueue.h stack.h

##################################################################

#  Main targets
 
nodebug: dirs $(LEPTLIB:%=$(LIB_NODEBUG)/%)

all:
	make -f Makefile TARGET=$(TARGET) nodebug
	make -f Makefile TARGET=$(TARGET) DEBUG=true debug
	make -f Makefile TARGET=$(TARGET) SHARED=true shared

DEBUG_LIBS = $(LEPTLIB:%=$(LIB_DEBUG)/%)
SHARED_LIBS = $(LEPTLIB_SHARED:%=$(LIB_SHARED)/%)
debug:	dirs $(DEBUG_LIBS)
shared:	dirs $(SHARED_LIBS)

##################################################################

#   Proto target
#
#  Note: To make the prototype file leptprotos.h requires the existence
#  of the xtractprotos executable.  However, we don't let the allprotos
#  target depend explicitly on xtractprotos because of a dependency loop
#  back on leptprotos.h, which causes an extra library compilation
#  when you 'make allprotos'.  Before making allprotos the first
#  time, 'make xtractprotos'  (Also, see the comments near the top
#  of this Makefile.)

allprotos:	leptprotos

leptprotos:	$(LEPTLIB_C)
		[ -f xtractprotos ] || echo "Please run 'make xtractprotos'"
		./xtractprotos $(LEPTLIB_C) > tempprotos.h
		mv tempprotos.h $(PROTOTYPE_DIR)/$@.h

##################################################################

#  xtractprotos

xtractprotos:	leptlib xtractprotos.o
	$(CC) -o xtractprotos xtractprotos.o $(LIB_NODEBUG)/liblept.a

xtractprotos.o:	../prog/xtractprotos.c

##################################################################

# Rule to make optimized library

$(LIB_NODEBUG)/%.a:
		$(RM) $@
		$(LIBRARIAN) $@ $<
		$(RANLIB) $@

# Rule to make debuggable library

$(LIB_DEBUG)/%.a:
		$(RM) $@
		$(LIBRARIAN) $@ $<
		$(RANLIB) $@

# Rule to make shared library

$(LIB_SHARED)/%.so:
		$(RM) $@
		$(LIBRARIAN_SHARED) $(SONAME_OPTION)$(notdir $@).$(MAJOR_REV) -o $@ $<
	mv $@ $@.$(MAJOR_REV).$(MINOR_REV)
	cd $(LIB_SHARED); rm $(notdir $@).$(MAJOR_REV); \
	  ln -s $(notdir $@).$(MAJOR_REV).$(MINOR_REV) $(notdir $@).$(MAJOR_REV)
	cd $(LIB_SHARED); rm $(notdir $@); \
	  ln -s $(notdir $@).$(MAJOR_REV) $(notdir $@)

##################################################################

# No-debug library dependencies and rules

leptlib:	$(LIB_NODEBUG)/$(LEPTLIB)
$(LIB_NODEBUG)/$(LEPTLIB):	$(LEPTLIB_C:%.c=$(OBJ_NODEBUG)/%.o)
		$(RM) $@
		$(LIBRARIAN) $@ $(LEPTLIB_C:%.c=$(OBJ_NODEBUG)/%.o)
		$(RANLIB) $@

# Debug library dependencies and rules

leptlibd:	$(LIB_DEBUG)/$(LEPTLIB)
$(LIB_DEBUG)/$(LEPTLIB):	$(LEPTLIB_C:%.c=$(OBJ_DEBUG)/%.o)
		$(RM) $@
		$(LIBRARIAN) $@ $(LEPTLIB_C:%.c=$(OBJ_DEBUG)/%.o)
		$(RANLIB) $@

# Shared library dependencies, rules and links

leptlibs:	$(LIB_SHARED)/$(LEPTLIB_SHARED)
$(LIB_SHARED)/$(LEPTLIB_SHARED):	$(LEPTLIB_C:%.c=$(OBJ_SHARED)/%.o)
		$(RM) $@
		$(LIBRARIAN_SHARED) $(SONAME_OPTION)$(notdir $@).$(MAJOR_REV) -o $@ $(LEPTLIB_C:%.c=$(OBJ_SHARED)/%.o)
	mv $@ $@.$(MAJOR_REV).$(MINOR_REV)
	cd $(LIB_SHARED); rm $(notdir $@).$(MAJOR_REV); \
	  ln -s $(notdir $@).$(MAJOR_REV).$(MINOR_REV) $(notdir $@).$(MAJOR_REV)
	cd $(LIB_SHARED); rm $(notdir $@); \
	  ln -s $(notdir $@).$(MAJOR_REV) $(notdir $@)

#########################################################

#  Rules for compiling source

$(OBJ_NODEBUG)/%.o:	%.c  $(LEPTLIB_H)
		@$(TEST) -d $(OBJ_NODEBUG) || $(MKDIRHIER) $(OBJ_NODEBUG)
		$(COMPILE.c) -o $@ $<

$(OBJ_DEBUG)/%.o:	%.c  $(LEPTLIB_H)
		@$(TEST) -d $(OBJ_DEBUG) || $(MKDIRHIER) $(OBJ_DEBUG)
		$(COMPILE.c) -o $@ $<

$(OBJ_SHARED)/%.o:	%.c  $(LEPTLIB_H)
		@$(TEST) -d $(OBJ_SHARED) || $(MKDIRHIER) $(OBJ_SHARED)
		$(COMPILE.c) -o $@ $<

###########################################################

# Prepare a local environment

dirs:
		@$(TEST) -d $(BASE_OBJ) || $(MKDIRHIER) $(BASE_OBJ)
		@$(TEST) -d $(OBJ_NODEBUG) || $(MKDIRHIER) $(OBJ_NODEBUG)
		@$(TEST) -d $(OBJ_DEBUG) || $(MKDIRHIER) $(OBJ_DEBUG)
		@$(TEST) -d $(OBJ_SHARED) || $(MKDIRHIER) $(OBJ_SHARED)
		@$(TEST) -d $(BASE_LIB) || $(MKDIRHIER) $(BASE_LIB)
		@$(TEST) -d $(LIB_NODEBUG) || $(MKDIRHIER) $(LIB_NODEBUG)
		@$(TEST) -d $(LIB_DEBUG) || $(MKDIRHIER) $(LIB_DEBUG)
		@$(TEST) -d $(LIB_SHARED) || $(MKDIRHIER) $(LIB_SHARED)


###########################################################

clean:		
		$(RM) $(OBJ_NODEBUG)/*.o $(OBJ_DEBUG)/*.o \
			$(OBJ_SHARED)/*.o \
			$(LIB_NODEBUG)/*.a $(LIB_DEBUG)/*.a \
			$(LIB_SHARED)/*.so $(LIB_SHARED)/*.so.? \
			$(LIB_SHARED)/*.so.?.? \
			xtractprotos.o xtractprotos

###########################################################

depend:
	/usr/X11R6/bin/makedepend -DNO_PROTOS $(CPPFLAGS) $(SRC)

###########################################################
# DO NOT DELETE THIS LINE -- make depend depends on it.

## leptonlib 1.45-2

=== prog/Makefile ===
#/*====================================================================*
# -  Copyright (C) 2001 Leptonica.  All rights reserved.
# -  This software is distributed in the hope that it will be
# -  useful, but with NO WARRANTY OF ANY KIND.
# -  No author or distributor accepts responsibility to anyone for the
# -  consequences of using this software, or for whether it serves any
# -  particular purpose or works at all, unless he or she says so in
# -  writing.  Everyone is granted permission to copy, modify and
# -  redistribute this source code, for commercial or non-commercial
# -  purposes, with the following restrictions: (1) the origin of this
# -  source code must not be misrepresented; (2) modified versions must
# -  be plainly marked as such; and (3) this notice may not be removed
# -  or altered from any source or modified source distribution.
# *====================================================================*/

#   Makefile  (for linux)
#
#   For a nodebug version:             make
#   For a debug version:               make DEBUG=yes
#   For a shared library version:      make SHARED=yes
#   With nonstandard library directories:
#                    make EXTRALIBS="-L<nonstandard-lib-dir>"
#   With nonstandard header directories
#                    make EXTRAINCLUDES="-I<nonstandard-incl-dir>"
#
#   To remove all executables:  make clean
#
#   To link and run programs using shared (dynamic linked) libraries,
#   you must do one of the following two things:
#
#     (a)  make sure your LD_LIBRARY_PATH variable points to the
#          directory in which the *.so files are placed, or
#     (b)  have the *.so files (or links to them) in this directory
#
#   On a bigendian machine (e.g., Mac), use
#      CPPFLAGS =	$(INCLUDES) -DL_BIG_ENDIAN
#
#   On cygwin, remove -fPIC from CC and remove the following targets:
#      alljpeg2ps.c      alltiff2ps.c
#      jbcorrelation.c   jbrankhaus.c
#      maketile.c        viewertest.c


# Libraries are built into a binary tree with its root in the
# parent directory
ROOT_DIR = ..

LIB_NODEBUG_DIR =	$(ROOT_DIR)/lib/nodebug
LIB_DEBUG_DIR =		$(ROOT_DIR)/lib/debug
LIB_SHARED_DIR =	$(ROOT_DIR)/lib/shared

# Include files are found within the same tree
IMAGELIB_INCL =	$(ROOT_DIR)/src


CC =		gcc -ansi -Werror -D_BSD_SOURCE -DANSI -fPIC
#CC =            g++ -Werror -D_BSD_SOURCE -fPIC


ifdef  SHARED
    LIB_DIR =	$(LIB_SHARED_DIR)
    OPTIMIZE =	-O2
else
    ifdef  DEBUG
	LIB_DIR =	$(LIB_DEBUG_DIR)
	OPTIMIZE =	-g
    else
	LIB_DIR =	$(LIB_NODEBUG_DIR)
	OPTIMIZE =	-O2
    endif
endif

OPTIONS =

INCLUDES =	-I$(IMAGELIB_INCL) -I/usr/X11R6/include $(EXTRAINCLUDES)
#INCLUDES =	-I$(IMAGELIB_INCL) -I/usr/X11R6/include -I/usr/local/include $(EXTRAINCLUDES)

CFLAGS =	$(OPTIMIZE) $(OPTIONS)
CPPFLAGS =      $(INCLUDES) -DL_LITTLE_ENDIAN
#CPPFLAGS =      $(INCLUDES) -DL_BIG_ENDIAN

LDFLAGS +=	-L$(LIB_DIR) -L/usr/X11R6/lib -L/usr/lib $(EXTRALIBS)
#LDFLAGS +=	-L$(LIB_DIR) -L/usr/X11R6/lib -L/usr/local/lib -L/usr/lib $(EXTRALIBS)

ifdef  SHARED
    LEPTLIB =		$(LIB_DIR)/liblept.so
else
    LEPTLIB =		$(LIB_DIR)/liblept.a
endif

ALL_LIBS =	$(LEPTLIB) -ltiff -ljpeg -lpng -lz -lm

#########################################################################

SRC =		binmorph1_reg.c binmorph2_reg.c \
		cmapquant_reg.c \
		conncomp_reg.c conversion_reg.c \
		equal_reg.c expand_reg.c \
		fhmtauto_reg.c flipdetect_reg.c \
		fmorphauto_reg.c \
		graymorph_reg.c ioformats_reg.c \
		morphseq_reg.c numa_reg.c \
		paint_reg.c pixa_reg.c \
		rank_reg.c rasterop_reg.c \
		rotate_reg.c rotateorth_reg.c \
		scale_reg.c string_reg.c \
		adaptmaptest.c affinetest.c \
		alljpeg2ps.c alltiff2ps.c \
		arithtest.c \
		baselinetest.c bilineartest.c \
		bincompare.c binmazetest.c \
		blendcmaptest.c blendtest1.c buffertest.c \
		ccbordtest.c cctest1.c \
		colormorphtest.c \
		colorquanttest.c colorsegtest.c \
		colorspacetest.c comparetest.c contrasttest.c \
		convertformat.c converttogray.c \
		converttops.c convolvetest.c cornertest.c \
		croptext.c distancetest.c dithertest.c \
		extrematest.c falsecolortest.c \
		fhmtautogen.c fileinfo.c \
		findpattern1.c findpattern2.c findpattern3.c \
		flipselgen.c \
		fmorphautogen.c \
		gammatest.c genfonts.c graphicstest.c \
		graymazetest.c graymorphtest.c \
		heaptest.c histotest.c iotest.c inserttest.c \
		jbcorrelation.c jbrankhaus.c jbwords.c \
		lineremoval.c listtest.c maketile.c \
		morphtest1.c mtifftest.c numaranktest.c \
		pagesegtest1.c pagesegtest2.c pagesegtest3.c \
		plottest.c \
		printimage.c printsplitimage.c printtiff.c \
		projectivetest.c reducetest.c \
		removecmap.c renderfonts.c \
		rotatefastalt.c rotateorthtest1.c \
		rotatetest1.c runlengthtest.c \
		scaletest1.c scaletest2.c \
		seedfilltest.c \
		sharptest.c sheartest.c showedges.c \
		skewtest.c snapcolortest.c \
		sorttest.c splitimage2pdf.c \
		thresholdtest.c viewertest.c wordsinorder.c \
		xvdisp.c

######################################################################

all:	$(SRC:%.c=%)

debian:	alljpeg2ps alltiff2ps binmazetest buffertest comparetest \
	cctest1 colormorphtest colorspacetest convertformat \
	converttops dithertest extrematest \
	fhmtauto_reg fhmtautogen fileinfo \
	flipdetect_reg flipselgen fmorphauto_reg fmorphautogen \
	gammatest genfonts graphicstest graymazetest graymorph_reg \
	heaptest histotest jbcorrelation jbrankhaus jbwords \
	lineremoval numaranktest pagesegtest1 \
	pagesegtest2 pagesegtest3 plottest \
	printimage printsplitimage printtiff \
	rank_reg removecmap sharptest splitimage2pdf viewertest

######################################################################

binmorph1_reg:	binmorph1_reg.o $(LEPTLIB)
	$(CC) -o binmorph1_reg binmorph1_reg.o $(ALL_LIBS) $(EXTRALIBS)

binmorph2_reg:	binmorph2_reg.o $(LEPTLIB)
	$(CC) -o binmorph2_reg binmorph2_reg.o $(ALL_LIBS) $(EXTRALIBS)

cmapquant_reg:	cmapquant_reg.o $(LEPTLIB)
	$(CC) -o cmapquant_reg cmapquant_reg.o $(ALL_LIBS) $(EXTRALIBS)

conncomp_reg: conncomp_reg.o $(LEPTLIB)
	$(CC) -o conncomp_reg conncomp_reg.o $(ALL_LIBS)

conversion_reg: conversion_reg.o $(LEPTLIB)
	$(CC) -o conversion_reg conversion_reg.o $(ALL_LIBS)

equal_reg:	equal_reg.o $(LEPTLIB)
	$(CC) -o equal_reg equal_reg.o $(ALL_LIBS) $(EXTRALIBS)

expand_reg:	expand_reg.o $(LEPTLIB)
	$(CC) -o expand_reg expand_reg.o $(ALL_LIBS) $(EXTRALIBS)

fhmtauto_reg:	fhmtauto_reg.o $(LEPTLIB)
	$(CC) -o fhmtauto_reg fhmtauto_reg.o $(ALL_LIBS) $(EXTRALIBS)

flipdetect_reg:	flipdetect_reg.o $(LEPTLIB)
	$(CC) -o flipdetect_reg flipdetect_reg.o $(ALL_LIBS) $(EXTRALIBS)

fmorphauto_reg:	fmorphauto_reg.o $(LEPTLIB)
	$(CC) -o fmorphauto_reg fmorphauto_reg.o $(ALL_LIBS) $(EXTRALIBS)

graymorph_reg:	graymorph_reg.o $(LEPTLIB)
	$(CC) -o graymorph_reg graymorph_reg.o $(ALL_LIBS) $(EXTRALIBS)

ioformats_reg:	ioformats_reg.o $(LEPTLIB)
	$(CC) -o ioformats_reg ioformats_reg.o $(ALL_LIBS) $(EXTRALIBS)

morphseq_reg:	morphseq_reg.o $(LEPTLIB)
	$(CC) -o morphseq_reg morphseq_reg.o $(ALL_LIBS) $(EXTRALIBS)

numa_reg:	numa_reg.o $(LEPTLIB)
	$(CC) -o numa_reg numa_reg.o $(ALL_LIBS) $(EXTRALIBS)

paint_reg:	paint_reg.o $(LEPTLIB)
	$(CC) -o paint_reg paint_reg.o $(ALL_LIBS) $(EXTRALIBS)

pixa_reg:	pixa_reg.o $(LEPTLIB)
	$(CC) -o pixa_reg pixa_reg.o $(ALL_LIBS) $(EXTRALIBS)

rank_reg:	rank_reg.o $(LEPTLIB)
	$(CC) -o rank_reg rank_reg.o $(ALL_LIBS) $(EXTRALIBS)

rasterop_reg:	rasterop_reg.o $(LEPTLIB)
	$(CC) -o rasterop_reg rasterop_reg.o $(ALL_LIBS) $(EXTRALIBS)

rotate_reg:	rotate_reg.o $(LEPTLIB)
	$(CC) -o rotate_reg rotate_reg.o $(ALL_LIBS) $(EXTRALIBS)

rotateorth_reg:	rotateorth_reg.o $(LEPTLIB)
	$(CC) -o rotateorth_reg rotateorth_reg.o $(ALL_LIBS) $(EXTRALIBS)

scale_reg:	scale_reg.o $(LEPTLIB)
	$(CC) -o scale_reg scale_reg.o $(ALL_LIBS) $(EXTRALIBS)

string_reg:	string_reg.o $(LEPTLIB)
	$(CC) -o string_reg string_reg.o $(ALL_LIBS) $(EXTRALIBS)

adaptmaptest:	adaptmaptest.o $(LEPTLIB)
	$(CC) -o adaptmaptest adaptmaptest.o $(ALL_LIBS) $(EXTRALIBS)

affinetest:	affinetest.o $(LEPTLIB)
	$(CC) -o affinetest affinetest.o $(ALL_LIBS) $(EXTRALIBS)

alljpeg2ps:	alljpeg2ps.o $(LEPTLIB)
	$(CC) -o alljpeg2ps alljpeg2ps.o $(ALL_LIBS) $(EXTRALIBS)

alltiff2ps:	alltiff2ps.o $(LEPTLIB)
	$(CC) -o alltiff2ps alltiff2ps.o $(ALL_LIBS) $(EXTRALIBS)

arithtest:	arithtest.o $(LEPTLIB)
	$(CC) -o arithtest arithtest.o $(ALL_LIBS) $(EXTRALIBS)

baselinetest:	baselinetest.o $(LEPTLIB)
	$(CC) -o baselinetest baselinetest.o $(ALL_LIBS) $(EXTRALIBS)

bilineartest:	bilineartest.o $(LEPTLIB)
	$(CC) -o bilineartest bilineartest.o $(ALL_LIBS) $(EXTRALIBS)

bincompare:	bincompare.o $(LEPTLIB)
	$(CC) -o bincompare bincompare.o $(ALL_LIBS) $(EXTRALIBS)

binmazetest:	binmazetest.o $(LEPTLIB)
	$(CC) -o binmazetest binmazetest.o $(ALL_LIBS) $(EXTRALIBS)

blendcmaptest:	blendcmaptest.o $(LEPTLIB)
	$(CC) -o blendcmaptest blendcmaptest.o $(ALL_LIBS) $(EXTRALIBS)

blendtest1:	blendtest1.o $(LEPTLIB)
	$(CC) -o blendtest1 blendtest1.o $(ALL_LIBS) $(EXTRALIBS)

buffertest:	buffertest.o $(LEPTLIB)
	$(CC) -o buffertest buffertest.o $(ALL_LIBS) $(EXTRALIBS)

ccbordtest:	ccbordtest.o $(LEPTLIB)
	$(CC) -o ccbordtest ccbordtest.o $(ALL_LIBS) $(EXTRALIBS)

cctest1:		cctest1.o $(LEPTLIB)
	$(CC) -o cctest1 cctest1.o $(ALL_LIBS) $(EXTRALIBS)

colormorphtest:	colormorphtest.o $(LEPTLIB)
	$(CC) -o colormorphtest colormorphtest.o $(ALL_LIBS) $(EXTRALIBS)

colorquanttest:	colorquanttest.o $(LEPTLIB)
	$(CC) -o colorquanttest colorquanttest.o $(ALL_LIBS) $(EXTRALIBS)

colorsegtest:	colorsegtest.o $(LEPTLIB)
	$(CC) -o colorsegtest colorsegtest.o $(ALL_LIBS) $(EXTRALIBS)

colorspacetest:	colorspacetest.o $(LEPTLIB)
	$(CC) -o colorspacetest colorspacetest.o $(ALL_LIBS) $(EXTRALIBS)

comparetest:	comparetest.o $(LEPTLIB)
	$(CC) -o comparetest comparetest.o $(ALL_LIBS) $(EXTRALIBS)

contrasttest:	contrasttest.o $(LEPTLIB)
	$(CC) -o contrasttest contrasttest.o $(ALL_LIBS) $(EXTRALIBS)

convertformat:	convertformat.o $(LEPTLIB)
	$(CC) -o convertformat convertformat.o $(ALL_LIBS) $(EXTRALIBS)

converttogray:	converttogray.o $(LEPTLIB)
	$(CC) -o converttogray converttogray.o $(ALL_LIBS) $(EXTRALIBS)

converttops:	converttops.o $(LEPTLIB)
	$(CC) -o converttops converttops.o $(ALL_LIBS) $(EXTRALIBS)

convolvetest:	convolvetest.o $(LEPTLIB)
	$(CC) -o convolvetest convolvetest.o $(ALL_LIBS) $(EXTRALIBS)

cornertest:	cornertest.o $(LEPTLIB)
	$(CC) -o cornertest cornertest.o $(ALL_LIBS) $(EXTRALIBS)

croptext:	croptext.o $(LEPTLIB)
	$(CC) -o croptext croptext.o $(ALL_LIBS) $(EXTRALIBS)

distancetest:	distancetest.o $(LEPTLIB)
	$(CC) -o distancetest distancetest.o $(ALL_LIBS) $(EXTRALIBS)

dithertest:	dithertest.o $(LEPTLIB)
	$(CC) -o dithertest dithertest.o $(ALL_LIBS) $(EXTRALIBS)

docseg1:	docseg1.o $(LEPTLIB)
	$(CC) -o docseg1 docseg1.o $(ALL_LIBS) $(EXTRALIBS)

docseg2:	docseg2.o $(LEPTLIB)
	$(CC) -o docseg2 docseg2.o $(ALL_LIBS) $(EXTRALIBS)

extrematest:	extrematest.o $(LEPTLIB)
	$(CC) -o extrematest extrematest.o $(ALL_LIBS) $(EXTRALIBS)

falsecolortest:	falsecolortest.o $(LEPTLIB)
	$(CC) -o falsecolortest falsecolortest.o $(ALL_LIBS) $(EXTRALIBS)

fhmtautogen:	fhmtautogen.o $(LEPTLIB)
	$(CC) -o fhmtautogen fhmtautogen.o $(ALL_LIBS) $(EXTRALIBS)

fileinfo:	fileinfo.o $(LEPTLIB)
	$(CC) -o fileinfo fileinfo.o $(ALL_LIBS) $(EXTRALIBS)

findpattern1:	findpattern1.o $(LEPTLIB)
	$(CC) -o findpattern1 findpattern1.o $(ALL_LIBS) $(EXTRALIBS)

findpattern2:	findpattern2.o $(LEPTLIB)
	$(CC) -o findpattern2 findpattern2.o $(ALL_LIBS) $(EXTRALIBS)

findpattern3:	findpattern3.o $(LEPTLIB)
	$(CC) -o findpattern3 findpattern3.o $(ALL_LIBS) $(EXTRALIBS)

flipselgen:	flipselgen.o $(LEPTLIB)
	$(CC) -o flipselgen flipselgen.o $(ALL_LIBS) $(EXTRALIBS)

fmorphautogen:	fmorphautogen.o $(LEPTLIB)
	$(CC) -o fmorphautogen fmorphautogen.o $(ALL_LIBS) $(EXTRALIBS)

gammatest:	gammatest.o $(LEPTLIB)
	$(CC) -o gammatest gammatest.o $(ALL_LIBS) $(EXTRALIBS)

genfonts:	genfonts.o $(LEPTLIB)
	$(CC) -o genfonts genfonts.o $(ALL_LIBS) $(EXTRALIBS)

graphicstest:	graphicstest.o $(LEPTLIB)

=== src/Makefile ===
--- 
+++ 
@@ -34,7 +34,29 @@
 #   (2) To generate function prototypes, you need a program called
 #       xtractprotos.  Build it with this command:
 #          make xtractprotos
-#       Then 'make allprotos'
+#       Then use it with 'make allprotos'
+#
+#   Customization for cygwin:
+#   (1) Remove viewfiles.c from source
+#   (2) Use the appropriate $CC
+#   (3) For the leptprotos target, the executable that has been
+#       built is xtractprotos.exe.  (add the ".exe")
+#
+#   Customization for Microsoft compilers (e.g., VC++6.0):
+#   (1) Substitute arrayaccess.h.ms60 for arrayaccess.h, if necessary
+#   (2) invoke with -DUSE_PSTDINT to use the pstdint.h file (included)
+#
+#   Customization for removing functions that depend on external
+#   libraries (jpeg, png, tiff, gzip), and I/O in general:
+#   (1) Replace selected files in the Makefile, from this set of stubs:
+#        bmpio.c   -->  bmpiostub.c
+#        jpegio.c  -->  jpegiostub.c
+#        pngio.c   -->  pngiostub.c
+#        pnmio.c   -->  pnmiostub.c
+#        psio.c    -->  psiostub.c
+#        tiffio.c  -->  tiffiostub.c
+#        zlibmem.c -->  zlibmemstub.c
+#   (2) Comment out selected I/O header files from alltypes.h
 #
 #   Stuff used by Makefile
 RM =		rm -f
@@ -47,9 +69,6 @@
 # Libraries are built into a binary tree with its root in the parent directory
 ROOT_DIR =	..
 
-# To find prog/xtractprotos.c when building the executable
-VPATH =	.:../prog
-
 BASE_OBJ =	$(ROOT_DIR)/obj
 OBJ_NODEBUG =	$(ROOT_DIR)/obj/nodebug
 OBJ_DEBUG =	$(ROOT_DIR)/obj/debug
@@ -62,7 +81,7 @@
 
 
 # Include files
-INCLUDES =	-I./ -I/usr/X11R6/include $(EXTRAINCLUDES)
+INCLUDES =	-I. $(EXTRAINCLUDES)
 PROTOTYPE_DIR =	.
 
 # Conditional compilation (depending on processor endian-ness)
@@ -91,8 +110,9 @@
 #     use -DNO_CONSOLE_IO to remove all L_INFO, L_WARNING and
 #        ERROR_* logging, and to remove all DEBUG information dependent
 #        on whether or not NO_CONSOLE_IO has been defined.
-#     remove -fPIC to avoid warnings on cygwin
+#     use -D_CYGWIN_ENVIRON (and without -fPIC) for cygwin
 CC =		gcc -ansi -Werror -D_BSD_SOURCE -DANSI -fPIC
+#CC =		gcc -ansi -Werror -D_CYGWIN_ENVIRON -DANSI
 #CC =		gcc -ansi -Werror -DNO_CONSOLE_IO -D_BSD_SOURCE -DANSI -fPIC
 #CC =		g++ -Werror -D_BSD_SOURCE -fPIC
 #CC =		g++ -Wunused -D_BSD_SOURCE -fPIC
@@ -110,19 +130,16 @@
 # Links are created among the files <libname>.X.Y,
 # <libname>.X, and <libname>, where Y is the minor revision number.
 MAJOR_REV = 1
-MINOR_REV = 37
+MINOR_REV = 45
 
 #########################################################
 
 # Libraries
 
 LEPTLIB =		liblept.a
-
 LEPTLIB_SHARED =	liblept.so
 
 #########################################################
-
-# Source:   (on cygwin, comment out viewfiles.c)
 
 LEPTLIB_C =	adaptmap.c \
 		affine.c \
@@ -134,27 +151,29 @@
 		binexpand.c binexpandlow.c \
 		binreduce.c binreducelow.c \
 		blend.c bmf.c bmpio.c \
-		box.c \
-		ccbord.c \
-		colormap.c colorquant.c colorseg.c \
-		conncomp.c \
+		boxbasic.c boxfunc.c \
+		ccbord.c classapp.c \
+		colorcontent.c colormap.c colormorph.c \
+		colorquant.c colorseg.c \
+		compare.c conncomp.c \
 		convolve.c convolvelow.c \
 		enhance.c \
 		fhmtauto.c \
 		fhmtgen.1.c fhmtgenlow.1.c \
-		fmorph.c \
+		flipdetect.c fliphmtgen.c \
 		fmorphauto.c \
 		fmorphgen.1.c fmorphgenlow.1.c \
-		fmorphlow.c \
 		gplot.c graphics.c \
 		graymorph.c graymorphlow.c \
 		grayquant.c grayquantlow.c \
 		jbclass.c jpegio.c \
 		list.c maze.c \
-		morph.c morphapp.c morphseq.c \
-		numarray.c paintcmap.c \
+		morph.c morphapp.c morphdwa.c morphseq.c \
+		numabasic.c numafunc.c \
+		pageseg.c paintcmap.c \
 		parseprotos.c pheap.c \
-		pix1.c pix2.c pixa.c pixarith.c pixconv.c \
+		pix1.c pix2.c pix3.c pixa.c \
+		pixacc.c pixarith.c pixconv.c \
 		pngio.c pnmio.c pqueue.c \
 		projective.c psio.c \
 		pts.c \
@@ -171,9 +190,7 @@
 		shear.c skew.c stack.c \
 		textops.c tiffio.c utils.c \
 		viewfiles.c \
-		writefile.c
-
-SRC =		$(LEPTLIB_C)
+		writefile.c zlibmem.c
 
 LEPTLIB_H =	allheaders.h alltypes.h \
 		array.h arrayaccess.h bbuffer.h \
@@ -212,22 +229,26 @@
 #  when you 'make allprotos'.  Before making allprotos the first
 #  time, 'make xtractprotos'  (Also, see the comments near the top
 #  of this Makefile.)
+#
+#  Note for cygwin: change the leptprotos target to:
+#     - test for xtractprotos.exe 
+#     - run ./xtractprotos.exe ...
 
 allprotos:	leptprotos
 
 leptprotos:	$(LEPTLIB_C)
-		[ -f xtractprotos ] || echo "Please run 'make xtractprotos'"
+		@$(TEST) -f xtractprotos || echo "First run 'make xtractprotos'"
 		./xtractprotos $(LEPTLIB_C) > tempprotos.h
 		mv tempprotos.h $(PROTOTYPE_DIR)/$@.h
 
 ##################################################################
 
 #  xtractprotos
-
+#
 xtractprotos:	leptlib xtractprotos.o
 	$(CC) -o xtractprotos xtractprotos.o $(LIB_NODEBUG)/liblept.a
 
-xtractprotos.o:	../prog/xtractprotos.c
+xtractprotos.o:	xtractprotos.c
 
 ##################################################################
 
@@ -324,17 +345,13 @@
 			$(OBJ_SHARED)/*.o \
 			$(LIB_NODEBUG)/*.a $(LIB_DEBUG)/*.a \
 			$(LIB_SHARED)/*.so $(LIB_SHARED)/*.so.? \
-			$(LIB_SHARED)/*.so.?.? \
+			$(LIB_SHARED)/*.so.?.* \
 			xtractprotos.o xtractprotos
 
 ###########################################################
 
 depend:
-	/usr/X11R6/bin/makedepend -DNO_PROTOS $(CPPFLAGS) $(SRC)
+	/usr/bin/makedepend -DNO_PROTOS $(CPPFLAGS) $(LEPTLIB_C)
 
 ###########################################################
 # DO NOT DELETE THIS LINE -- make depend depends on it.
-
-
-
-

=== debian/changelog ===
leptonlib (1.45-2) unstable; urgency=low

  * Add sample images

 -- Jeff Breidenbach <jab@debian.org>  Fri,  1 Jun 2007 15:56:49 -0700

leptonlib (1.45-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Fri,  1 Jun 2007 13:59:43 -0700

leptonlib (1.43-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Tue,  3 Apr 2007 14:31:18 -0700

leptonlib (1.42-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Tue, 23 Jan 2007 15:52:37 -0800

leptonlib (1.37-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Thu, 13 Jul 2006 11:24:50 -0700

leptonlib (1.36-1) unstable; urgency=low

  * Initial Release.

 -- Jeff Breidenbach <jab@debian.org>  Tue, 27 Jun 2006 14:50:37 -0700

=== debian/control ===
Source: leptonlib
Priority: optional
Maintainer: Jeff Breidenbach <jab@debian.org>
Build-Depends: debhelper (>= 4.0.0), libtiff4-dev (>= 3.7.4), libpng12-dev
Standards-Version: 3.7.2
Section: graphics

Package: libleptonica-dev
Section: libdevel
Architecture: any
Depends: libleptonica (= ${Source-Version})
Description: image processing library
 Well-tested C library for some basic image processing operations,
 along with a description of the functions and some design methods. A
 full set of affine transformations (translation, shear, rotation,
 scaling) on images of all depths is included, with the exception that
 some of the scaling methods do not work at all depths. There are also
 implementations of binary morphology, grayscale morphology,
 convolution and rank order filters, and applications such as jbig2
 image processing and color quantization. You will also find basic
 utilities for the safe and efficient handling of arrays (of strings,
 numbers, number pairs and image-related geometrical objects), byte
 queues, generic stacks, generic lists, and endian-independent
 indexing into 32-bit arrays.

Package: libleptonica
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, libtiff4 (>= 3.7.4), libpng12-0
Description: image processing library
 Well-tested C library for some basic image processing operations,
 along with a description of the functions and some design methods. A
 full set of affine transformations (translation, shear, rotation,
 scaling) on images of all depths is included, with the exception that
 some of the scaling methods do not work at all depths. There are also
 implementations of binary morphology, grayscale morphology,
 convolution and rank order filters, and applications such as jbig2
 image processing and color quantization. You will also find basic
 utilities for the safe and efficient handling of arrays (of strings,
 numbers, number pairs and image-related geometrical objects), byte
 queues, generic stacks, generic lists, and endian-independent
 indexing into 32-bit arrays.

Package: leptonica-progs
Section: graphics
Architecture: any
Depends: ${shlibs:Depends}
Description: sample programs for Leptonica image processing library
 Well-tested C library for some basic image processing operations,
 along with a description of the functions and some design methods. A
 full set of affine transformations (translation, shear, rotation,
 scaling) on images of all depths is included, with the exception that
 some of the scaling methods do not work at all depths. There are also
 implementations of binary morphology, grayscale morphology,
 convolution and rank order filters, and applications such as jbig2
 image processing and color quantization. You will also find basic
 utilities for the safe and efficient handling of arrays (of strings,
 numbers, number pairs and image-related geometrical objects), byte
 queues, generic stacks, generic lists, and endian-independent
 indexing into 32-bit arrays.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# shared library versions, option 1
version=1.0
major=1


build: build-stamp
build-stamp:
	dh_testdir
	# Add here commands to compile the package.
	cd src && $(MAKE) all
	cd prog && $(MAKE) SHARED=yes debian
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	# Add here commands to clean up after the build process.
	cd src && $(MAKE) clean
	cd prog && $(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	install -d $(CURDIR)/debian/tmp/usr/lib
	install -d $(CURDIR)/debian/tmp/usr/include/leptonica
	cp -pvrdf lib/shared/liblept* $(CURDIR)/debian/tmp/usr/lib
	install lib/nodebug/liblept* $(CURDIR)/debian/tmp/usr/lib
	install -m 644 src/*.h $(CURDIR)/debian/tmp/usr/include/leptonica
	cd prog && $(MAKE) install DESTDIR=$(CURDIR)/debian/tmp


# Build architecture-independent files here.
binary-indep: build install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install --sourcedir=debian/tmp
	dh_installman -p leptonica-progs debian/*.1
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
